<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, 'account_bfip');
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_ACC_BFIP_ID',
							'PARAM_ACC_BFIP_IP', 
							'PARAM_ACC_BFIP_DESCRIPTION', 
							'PARAM_ACC_BFIP_FAIL_COUNT', 
							'PARAM_ACC_BFIP_LOCK_COUNT', 
							'PARAM_ACC_BFIP_SUCCESS_COUNT', 
							'PARAM_ACC_BFIP_STATUS'
							// , 'PARAM_ACC_BFIP_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_ACC_BFIP_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_ID', true);
			$PARAM_ACC_BFIP_IP = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_BFIP_IP', true);
			$PARAM_ACC_BFIP_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_BFIP_DESCRIPTION', true);
			$PARAM_ACC_BFIP_FAIL_COUNT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_FAIL_COUNT', true);
			$PARAM_ACC_BFIP_LOCK_COUNT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_LOCK_COUNT', true);
			$PARAM_ACC_BFIP_SUCCESS_COUNT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_BFIP_SUCCESS_COUNT', true);
			$PARAM_ACC_BFIP_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ACC_BFIP_STATUS', true);
			
			//$PARAM_ACC_BFIP_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_ACC_BFIP_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_ACC_BFIP_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_ACC_BFIP_ID,
							$PARAM_ACC_BFIP_IP, 
							$PARAM_ACC_BFIP_DESCRIPTION, 
							$PARAM_ACC_BFIP_FAIL_COUNT, 
							$PARAM_ACC_BFIP_LOCK_COUNT, 
							$PARAM_ACC_BFIP_SUCCESS_COUNT, 
							$PARAM_ACC_BFIP_STATUS
					]
			);
			
				
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_ACCOUNT_BFIP::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_ID'] = $PARAM_ACC_BFIP_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_IP'] = $PARAM_ACC_BFIP_IP[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_DESCRIPTION'] = $PARAM_ACC_BFIP_DESCRIPTION[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_FAIL_COUNT'] = $PARAM_ACC_BFIP_FAIL_COUNT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_LOCK_COUNT'] = $PARAM_ACC_BFIP_LOCK_COUNT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_SUCCESS_COUNT'] = $PARAM_ACC_BFIP_SUCCESS_COUNT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_ACC_BFIP_STATUS'] = $PARAM_ACC_BFIP_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_ACCOUNT_BFIP::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
					(
						$PARAM_ACC_BFIP_ID_FILE['tmp_name'],
						PHPSET::$ROOT . '/Server/Account/bfip/file/' . $DATA_SET[0]['INSERTED_ID'] . '.' .
						PHPVC_STR::VAR_LCASE(PathInfo($PARAM_ACC_BFIP_ID_FILE['name'], PATHINFO_EXTENSION))
					);
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>